VERSION 5.00
Begin VB.Form frmTrackPopupMenu 
   AutoRedraw      =   -1  'True
   Caption         =   "API PopUp Menu"
   ClientHeight    =   3165
   ClientLeft      =   3210
   ClientTop       =   1530
   ClientWidth     =   5610
   Icon            =   "frmTrackPopupMenu.frx":0000
   LinkTopic       =   "Form1"
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   211
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   374
   Begin VB.Label Label1 
      Caption         =   "Right click anywhere on the client area of the form to see an API created popup menu."
      Height          =   480
      Left            =   165
      TabIndex        =   0
      Top             =   285
      Width           =   5325
   End
End
Attribute VB_Name = "frmTrackPopupMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how to use the API menu functions to create a
  ' popup menu. by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without warranty or
  ' guaranty of any kind.  In other words, use at your own risk.
  
  
  ' the handles to our popup menus.  we keep them at the module level so that
  ' we don't have to recreate the menus each time we want to display them.
  Private m_hPopup As Long
  Private m_hEdit As Long


  Private Type POINTAPI
    x As Long
    y As Long
  End Type
    
  Private Const MF_INSERT As Long = &H0&
  Private Const MF_CHANGE As Long = &H80&
  Private Const MF_APPEND As Long = &H100&
  Private Const MF_DELETE As Long = &H200&
  Private Const MF_REMOVE As Long = &H1000&
  Private Const MF_BYCOMMAND As Long = &H0&
  Private Const MF_BYPOSITION As Long = &H400&
  Private Const MF_SEPARATOR As Long = &H800&
  Private Const MF_ENABLED As Long = &H0&
  Private Const MF_GRAYED As Long = &H1&
  Private Const MF_DISABLED As Long = &H2&
  Private Const MF_UNCHECKED As Long = &H0&
  Private Const MF_CHECKED As Long = &H8&
  Private Const MF_USECHECKBITMAPS As Long = &H200&
  Private Const MF_STRING As Long = &H0&
  Private Const MF_BITMAP As Long = &H4&
  Private Const MF_OWNERDRAW As Long = &H100&
  Private Const MF_POPUP As Long = &H10&
  Private Const MF_MENUBARBREAK As Long = &H20&
  Private Const MF_MENUBREAK As Long = &H40&
  Private Const MF_UNHILITE As Long = &H0&
  Private Const MF_HILITE As Long = &H80&
  Private Const MF_SYSMENU As Long = &H2000&
  Private Const MF_HELP As Long = &H4000&
  Private Const MF_MOUSESELECT As Long = &H8000&


  Private Const TPM_RETURNCMD As Long = &H100&

  Private Declare Function CreatePopupMenu Lib "user32" () As Long
  Private Declare Function DestroyMenu Lib "user32" (ByVal hMenu&) As Long
  Private Declare Function AppendMenu Lib "user32" Alias "AppendMenuA" (ByVal hMenu&, ByVal wFlags&, ByVal wIDNewItem&, ByVal lpNewItem$) As Long
  Private Declare Function ClientToScreen& Lib "user32" (ByVal hWnd&, lpPoint As POINTAPI)
  Private Declare Function TrackPopupMenu Lib "user32" (ByVal hMenu&, ByVal wFlags&, ByVal x&, ByVal y&, ByVal nReserved&, ByVal hWnd&, ByVal lpRect&) As Long
  Private Declare Function EnableMenuItem Lib "user32" (ByVal hMenu&, ByVal wIDEnableItem&, ByVal wEnable&) As Long

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
  ' if the right button was pressed, display the popup menu....
  If Button = vbRightButton Then DisplayPopupMenu x, y
End Sub

Private Sub Label1_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
  ' if the right button was pressed, display the popup menu.
  ' we need to translate the coordinates to be relevant in the context of the form.
  With Screen
    If Button = vbRightButton Then DisplayPopupMenu (x \ .TwipsPerPixelX) + Label1.Left, (y \ .TwipsPerPixelY) + Label1.Top
  End With
End Sub

Private Sub DisplayPopupMenu(ByVal x&, ByVal y&)

  Dim pt As POINTAPI
  
  Const ID_BEEP As Long = &H6000&
  Const ID_SEPERATOR As Long = &H6001
  Const ID_DISABLED As Long = &H6002&
  Const ID_MSGBOX As Long = &H6003&

  Const ID_EDIT As Long = &H6004&
  Const ID_PASTE As Long = &H6005&

  ' if the menu hasn't already been created, create it....
  If m_hPopup = 0 Then
    ' first create our sub menu....
    m_hEdit = CreatePopupMenu()
    
    ' add a couple of items to the sub menu....
    Call AppendMenu(m_hEdit, MF_STRING, ID_EDIT, ByVal "Edit...")
    Call AppendMenu(m_hEdit, MF_STRING, ID_PASTE, ByVal "Paste...")
    
    
    m_hPopup = CreatePopupMenu()
  
    ' add an item....
    Call AppendMenu(m_hPopup, MF_STRING, ID_BEEP, ByVal "Sound A ""Beep""")
    
    ' add a seperator....
    Call AppendMenu(m_hPopup, MF_STRING Or MF_SEPARATOR, ID_SEPERATOR, ByVal vbNullString)
    
    ' add the item to which we attach the sub menu....
    Call AppendMenu(m_hPopup, MF_STRING Or MF_POPUP, m_hEdit, ByVal "Sub Menu...")
    
    ' add another item....
    Call AppendMenu(m_hPopup, MF_STRING, ID_DISABLED, ByVal "A Disabled Item")
    ' disable the last item we added....
    Call EnableMenuItem(m_hPopup, ID_DISABLED, MF_BYCOMMAND Or MF_DISABLED Or MF_GRAYED)
    
    ' add the last item....
    Call AppendMenu(m_hPopup, MF_STRING, ID_MSGBOX, ByVal "Display A MessageBox")
  End If
  

  With pt  ' the x & y position where you want the menu displayed
    .x = x
    .y = y
    
    ' translate to screen coordiantes
    Call ClientToScreen(hWnd, pt)

    ' call the api function to display the menu and check the return value
    Select Case TrackPopupMenu(m_hPopup, TPM_RETURNCMD, .x, .y, 0&, hWnd, 0&)
      Case ID_BEEP
        Beep
      
      Case ID_MSGBOX
        MsgBox "This is a messagebox.", vbExclamation
        
      Case ID_EDIT
        MsgBox "You chose ""Edit"".", vbExclamation
      
      Case ID_PASTE
        MsgBox "You chose ""Paste"".", vbExclamation
      
    End Select
  End With
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
  ' be sure to destroy the menu before exiting....
  If m_hPopup Then
    Call DestroyMenu(m_hPopup)
    Call DestroyMenu(m_hEdit)
  End If
End Sub
